<?php

namespace App\Service;

class Delay 
{
    private $delayFactory;

    public function __construct(\App\Factory\Delay $delayFactory) 
    {
        $this->delayFactory = $delayFactory;
    }

    public function getStore($cdFilial)
    {
        $resultado = array();
        $valoresUnicos = array();

        $store = $this->delayFactory->getStore($cdFilial);

        foreach ($store as $chave => $valor) {
            $novoId = isset($valor['ID']) ? $valor['ID'] : str_pad(mt_rand(100, 999), 3, '0', STR_PAD_LEFT);
            
            if (isset($valor['CDFILIAL']) && !empty($valor['CDFILIAL'])) {
                $novoItem = [
                    "CDFILIALGRID" => $valor['CDFILIAL'],
                    "ID" => $valor['CDFILIAL'],
                    "NMFILIAL" => $valor['NMFILIAL']
                ];
                $chaveUnica = $valor['CDFILIAL'];
        
                if (!isset($valoresUnicos[$chaveUnica])) {
                    $resultado[] = $novoItem;
                    $valoresUnicos[$chaveUnica] = true;
                }
            }

            if ($valor['CDLOJA']) {
                unset($valor['NMFILIAL']);
            }

            $resultado[] = array_merge(
                $valor,
                ["PARENT_ITEM" => isset($novoItem['CDFILIALGRID']) ? $novoItem['CDFILIALGRID'] : null],
                ["ID" => $novoId]
            );

            if (!isset($valor["HRTEMPOATRASO"]) || $valor["HRTEMPOATRASO"] == 0) {
                $resultado[count($resultado) - 1]["HRTEMPOATRASO"] = " - ";
            }
        }

        return $resultado;
    }

    public function filter($cdFilial)
    {
        return $this->delayFactory->getStore($cdFilial);
    }

    public function updateDelay($paramsUpdate)
    {
        return$this->delayFactory->updateDelay($paramsUpdate);
    }

    public function getParamsValue($data, $indexName) 
    {
        $valuesToSave = [];
    
        if (isset($data[$indexName])) {
            foreach ($data[$indexName] as $key => $item) {
                if (isset($item["CDFILIAL"])) {
                    $valuesToSave[] = $item["CDFILIAL"];
                    unset($data[$indexName][$key]);
                }
            }
            if (!empty($valuesToSave)) {
                return implode(',', $valuesToSave);
            }
        }
    
        return "T";
    }
}